pipeline {
  agent any

  stages {
    stage("Running Tests") {
      environment {
        PYTHONPATH = credentials('PYTHONPATH')
        SETTINGS_ENVIRONMENT = credentials('SETTINGS_ENVIRONMENT')
        APPLICATION_METADATA = credentials('APPLICATION_METADATA')
        UVICORN_ARGUMENTS = credentials('UVICORN_ARGUMENTS')
        ALLOW_ORIGINS = credentials('ALLOW_ORIGINS')
        ALLOW_METHODS = credentials('ALLOW_METHODS')
        ALLOW_HEADERS = credentials('ALLOW_HEADERS')
        ALLOW_CREDENTIALS = credentials('ALLOW_CREDENTIALS')
        DATABASE_URL = credentials('DATABASE_URL')
        SESSION_OPTIONS = credentials('SESSION_OPTIONS')
      }

      steps {
        sh """
        echo 'Hello World!'
        touch ./environments/development.env
        set > ./environments/development.env
        docker-compose -f integration/docker-compose.yml up -d --build
        docker exec -i fast-api-example-service bash -c 'pytest --cache-clear -vvv tests/unit/'
        docker exec -i fast-api-example-service bash -c 'pytest --cache-clear -vvv tests/integration/'
        """
      }
    }
  }
}